//+--------------------------------------------------------------------------------------------+
//|   Klinger.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Green
#property indicator_color2  Green
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  Gray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2

extern int FastX   = 34;
extern int SlowX   = 55;
extern int TrigLen = 13;
extern int Smooth  = 5;

double kvouu[];
double kvoud[];
double kvodd[];
double kvodu[];
double KVOl[];
double Signal[];
double slope[];

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);      
   SetIndexBuffer(0,kvouu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,kvoud);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,kvodd);  SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,kvodu);  SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,KVOl);
   SetIndexBuffer(5,Signal); 
   SetIndexBuffer(6,slope); 
      Smooth = MathMax(Smooth,1);
   return(0);
}
int deinit() { return(0); }

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

double work[][6];
#define _TSum   0
#define _Trend  1
#define _CM     2
#define _VForce 3
#define _Kvo    4
#define _Triger 5

int start()
{
  int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_TSum]  = High[i]+Low[i]+Close[i];
      work[r][_Trend] = work[r-1][_Trend] ;
         if (work[r][_TSum] > work[r-1][_TSum]) work[r][_Trend] =  1;
         if (work[r][_TSum] < work[r-1][_TSum]) work[r][_Trend] = -1;
         if (work[r][_Trend] == work[r-1][_Trend])
               work[r][_CM] = High[i] - Low[i] + work[r-1][_CM];
         else  work[r][_CM] = High[i] - Low[i] + High[i+1] - Low[i+1];
         
         //
         //
         //
         //
         //
         
         double dm = 0; if ((Low[i]-Low[i+1])<0) dm = -(Low[i]-Low[i+1]);
            if (work[r][_CM]!= 0)
                  work[r][_VForce] = Volume[i]*MathAbs(2*(dm/work[r][_CM])-1)*work[r][_Trend]*100.0;
            else  work[r][_VForce] = work[r-1][_VForce];
         work[r][_Kvo]    = iEma(work[r][_VForce],FastX,i,0)-iEma(work[r][_VForce],SlowX,i,1);
         work[r][_Triger] = iEma(work[r][_Kvo],TrigLen,i,2);
         
         //
         //
         //
         //
         //

         KVOl[i]   = iSsm(work[r][_Kvo]   ,Smooth,i,0);
         Signal[i] = iSsm(work[r][_Triger],Smooth,i,1);
         slope[i]  = slope[i+1];               
            kvouu[i] = EMPTY_VALUE;
            kvoud[i] = EMPTY_VALUE;
            kvodd[i] = EMPTY_VALUE;
            kvodu[i] = EMPTY_VALUE;
            if (KVOl[i]>KVOl[i+1]) slope[i] =  1;
            if (KVOl[i]<KVOl[i+1]) slope[i] = -1;
            if (KVOl[i] > 0)
               if (slope[i]==1)
                     kvouu[i] = KVOl[i];
               else  kvoud[i] = KVOl[i];
            if (KVOl[i] < 0)
               if (slope[i]==1)
                     kvodu[i] = KVOl[i];
               else  kvodd[i] = KVOl[i];
   }
   return(0);
}

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

double workEma[][3];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][4];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period <= 1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}

